# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from edgeimpulse_api.models.storage_provider import StorageProvider

class AddOrganizationBucketRequest(BaseModel):
    access_key: StrictStr = Field(..., alias="accessKey", description="Access key for the storage service (e.g., S3 access key, GCS access key)")
    secret_key: StrictStr = Field(..., alias="secretKey", description="Secret key for the storage service (e.g., S3 secret key, GCS secret key)")
    endpoint: StrictStr = Field(..., description="Endpoint URL for the storage service (e.g., S3 endpoint, custom endpoint for other services) ")
    bucket: StrictStr = Field(..., description="Name of the storage bucket")
    region: StrictStr = Field(..., description="Region of the storage service (if applicable)")
    check_connectivity_prefix: Optional[StrictStr] = Field(None, alias="checkConnectivityPrefix", description="Set this if you don't have access to the root of this bucket. Only used to verify connectivity to this bucket. ")
    storage_provider: Optional[StorageProvider] = Field(None, alias="storageProvider")
    __properties = ["accessKey", "secretKey", "endpoint", "bucket", "region", "checkConnectivityPrefix", "storageProvider"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = False

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self,indent=None) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict(),indent=indent)

    @classmethod
    def from_json(cls, json_str: str) -> AddOrganizationBucketRequest:
        """Create an instance of AddOrganizationBucketRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AddOrganizationBucketRequest:
        """Create an instance of AddOrganizationBucketRequest from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return AddOrganizationBucketRequest.construct(**obj)

        _obj = AddOrganizationBucketRequest.construct(**{
            "access_key": obj.get("accessKey"),
            "secret_key": obj.get("secretKey"),
            "endpoint": obj.get("endpoint"),
            "bucket": obj.get("bucket"),
            "region": obj.get("region"),
            "check_connectivity_prefix": obj.get("checkConnectivityPrefix"),
            "storage_provider": obj.get("storageProvider")
        })
        return _obj

